# Rozdział 3. Inteligentne przeszukiwanie
## Przeszukiwanie sterowane
Przeszukiwanie sterowane (nazywane też heurystycznym) to algorytm wykorzystujący przeszukiwanie wszerz i w głąb w połączeniu 
z „inteligencją”. Przeszukiwanie jest sterowane heurystyką bazującą na wiedzy o problemie.

Algorytm A* zwykle poprawia wydajność dzięki heurystyce minimalizowania kosztu następnego odwiedzanego węzła.
Łączny koszt jest obliczany na podstawie dwóch cech: łącznej odległości od węzła początkowego do danego i szacowanego 
kosztu przejścia do danego węzła za pomocą heurystyki. Gdy chcesz zminimalizować koszt, niższa wartość oznacza wydajniejsze rozwiązanie.

## Przeszukiwanie antagonistyczne
Przeszukiwanie antagonistyczne cechuje się obecnością opozycji lub konfliktów. Takie problemy wymagają przewidywania działań 
przeciwnika, zrozumienia ich i przeciwdziałania im, aby zrealizować cele. Przykładowe problemy antagonistyczne to gry dwuosobowe 
z naprzemiennie wykonywanymi ruchami takie jak szachy, kółko i krzyżyk lub czwórki.

Algorytm min-max ma generować drzewo możliwych skutków oparte na ruchach, jakie może wykonać każdy gracz, i preferować ścieżki 
korzystne dla danego agenta oraz unikać ścieżek korzystnych dla przeciwnika. W tym celu algorytm symuluje możliwe ruchy i na podstawie 
heurystyki ocenia stan po wykonaniu poszczególnych posunięć.
Algorytm min-max próbuje sprawdzić możliwie dużo przyszłych stanów. Jednak z powodu ograniczeń pamięciowych i obliczeniowych sprawdzenie 
całego drzewa gry może okazać się niewykonalne, dlatego przeszukiwanie jest kontynuowane do określonej głębokości.